; Fractal
; (c) Gigasoft 12-27-2009

bits 16
org 7c00h

xor ax,ax
mov ss,ax
mov sp,ax
mov ds,ax
sti
fninit
mov ax,1130h
mov bh,2
int 10h
mov [7e00h],cx
mov [7e02h],bp
push es
pop fs
mov ax,13h
int 10h
mov cx,63
palloop:
mov dx,3c8h
mov al,cl
out dx,al
inc dx
out dx,al
out dx,al
shr al,1
out dx,al
dec cx
jns palloop
mainloop:
mov bp,sp
push word 0a000h
pop es
fild word [minus9]
fild dword [count1]
fscale
fsincos
fxch st2,st0
fild dword [count2]
fscale
fsin
fadd dword [bias]
fld st0
fmul st2
fstp dword [bp+8h]
fmul st2
fstp dword [bp+0ch]
fstp st0
fstp st0
fstp st0
add dword [count1],25
add dword [count2],3
pixloop:
movzx eax,di
mov ecx,320
xor dx,dx
div cx
push ax
sub ax,100
sub dx,160
push dx
push ax
fild word [minus7]
fild word [bp-4]
fscale
fxch st1,st0
fild word [bp-6]
fscale
fstp st1
mov ax,63
iterloop:
fld st0
fmul st2
fadd st0
fadd dword [bp+12]
fld st1
fmul st0
fld st3
fmul st0
fld st0
fsub st2
fadd dword [bp+8]
fstp st4
fxch st2,st0
fstp st4
faddp st1,st0
fld dword [highval]
fcomi st0,st1
fstp st0
fstp st0
jb iterdone
dec ax
jnz iterloop
iterdone:
fstp st0
fstp st0
stosb
pop ax
pop ax
pop cx
inc cx
movsx eax,ax
imul eax,eax,13fffh
cdq
idiv ecx
add eax,8000h
test eax,0ffff0000h
jnz nextpix
push ax
mov eax,03ffffh
cdq
idiv ecx
xor ax,0ffffh
add ax,[7e04h]
pop dx
mov bl,ah
shr bl,1
jb nextpix
and bx,byte 7
mov bx,[bx+textofs]
sub bh,bl
mov cl,8
sub cl,bh
shr dx,4
sub dh,cl
add bh,bh
cmp dh,bh
jae nextpix
shr dx,1
add bl,dh
shr dx,5
and dx,byte 7
mov bh,0
mov bl,[bx+t1]
imul bx,bx,14
add bx,[7e02h]
mov ah,0
shr al,4
add bx,ax
xor dl,7
bt [fs:bx],dx
jae nextpix
xor byte [es:di-1],63
nextpix:
test di,di
jnz near pixloop
add word [7e04h],byte 12
jmp mainloop
OutHex:
mov cx,4
hexlp:
rol dx,4
mov ax,dx
and al,15
add al,65
mov ah,14
mov bl,7
int 10h
loop hexlp
ret
textofs db t1-t1,t2-t1,t3-t1,t4-t1,t5-t1,t6-t1,t7-t1,t8-t1,highval-t1
t1 db "Gigasoft"
t2 db "Boot"
t3 db "Sector"
t4 db "Fractal"
t5 db "(c)12-27"
t6 db "2009"
t7 db "Hello to"
t8 db "OsDevOrg"
highval dd 44800000h
bias dd 3f600000h
minus9 dw -9
minus7 dw -7
count1 dd 4bh
count2 dd 0785h
times 510-($-$$) db 0
dw 0aa55h